//---------------------------------------------------------------------------

#include <vcl.h>
#include <iostream>
#include <iterator>
#include <vector>
#include <algorithm>
#include <functional>

#include "compose21.hpp"

#include <conio.h> //  getch()

#pragma hdrstop

//---------------------------------------------------------------------------

#pragma argsused
using namespace std;


std::string ToRus(const std::string &in)
{
  char *buff = new char [in.length()+1];
  CharToOem(in.c_str(),buff);
  std::string out(buff);
  delete [] buff;
  return out;
}

template <class T>
inline void PRINT_ELEMENTS (const T& coll, const char* optcstr="")
{
  typename T::const_iterator pos;
  std::cout << ToRus(optcstr);
  for (pos=coll.begin(); pos!=coll.end(); ++pos) {
    std::cout <<*pos <<' ';
  }
  std::cout << std::endl;
}

int main()
{
  vector<int> coll;

  //      1  9
  for (int i=1; i<=9; ++i) {
      coll.push_back(i);
  }
  PRINT_ELEMENTS(coll," :\n");

  //   ,  4,   7
  // - retain new end
  vector<int>::iterator pos;
  pos = remove_if (coll.begin(),coll.end(),
                   compose_f_gx_hx(logical_and<bool>(),
                                   bind2nd(greater<int>(),4),
                                   bind2nd(less<int>(),7)));

  //  ""   
  coll.erase(pos,coll.end());

  PRINT_ELEMENTS(coll,"  :\n");


  getch();
  return 0;
}

//---------------------------------------------------------------------------